#lang racket
(require rackunit)
(require "stream.rkt")
(require "stream-map.rkt")
(require "naturals.rkt")
(require "even-nats.rkt")
(require "stream-zip.rkt")
(provide stream-enum)

(define (stream-enum s)
  (stream-zip (naturals) s))

(define s0 (stream-enum (even-naturals)))
(check-equal? (stream-get s0) (cons 0 0))
(define s1 (stream-next s0))
(check-equal? (stream-get s1) (cons 1 2))
(define s2 (stream-next s1))
(check-equal? (stream-get s2) (cons 2 4))
